/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2018 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.blocks.tier0;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1799;
import net.minecraft.class_1922;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2371;
import net.minecraft.class_2398;
import net.minecraft.class_2586;
import net.minecraft.class_2680;
import net.minecraft.class_3417;
import net.minecraft.class_3419;
import reborncore.api.blockentity.IMachineGuiHandler;
import reborncore.common.blocks.BlockMachineBase;
import techreborn.client.EGui;
import techreborn.blockentity.machine.iron.IronFurnaceBlockEntity;

import java.util.Random;

public class BlockIronFurnace extends BlockMachineBase {

	@SuppressWarnings("incomplete-switch")
	@Environment(EnvType.CLIENT)
	public void method_9496(class_2680 stateIn, class_1937 worldIn, class_2338 pos, Random rand) {
		if (this.isActive(stateIn)) {

			final double d0 = pos.method_10263() + 0.5D;
			final double d1 = pos.method_10264() + rand.nextDouble() * 6.0D / 16.0D;
			final double d2 = pos.method_10260() + 0.5D;
			if (rand.nextDouble() < 0.1D) {
				worldIn.method_8486(d0, d1, d2, class_3417.field_15006, class_3419.field_15245, 1.0F, 1.0F,
						false);
			}

			final class_2350 enumfacing = stateIn.method_11654(BlockMachineBase.FACING);
			final double d3 = 0.52D;
			final double d4 = rand.nextDouble() * 0.6D - 0.3D;

			switch (enumfacing) {
			case field_11039:
				worldIn.method_8406(class_2398.field_11251, d0 - d3, d1, d2 + d4, 0.0D, 0.0D, 0.0D);
				worldIn.method_8406(class_2398.field_11240, d0 - d3, d1, d2 + d4, 0.0D, 0.0D, 0.0D);
				break;
			case field_11034:
				worldIn.method_8406(class_2398.field_11251, d0 + d3, d1, d2 + d4, 0.0D, 0.0D, 0.0D);
				worldIn.method_8406(class_2398.field_11240, d0 + d3, d1, d2 + d4, 0.0D, 0.0D, 0.0D);
				break;
			case field_11043:
				worldIn.method_8406(class_2398.field_11251, d0 + d4, d1, d2 - d3, 0.0D, 0.0D, 0.0D);
				worldIn.method_8406(class_2398.field_11240, d0 + d4, d1, d2 - d3, 0.0D, 0.0D, 0.0D);
				break;
			case field_11035:
				worldIn.method_8406(class_2398.field_11251, d0 + d4, d1, d2 + d3, 0.0D, 0.0D, 0.0D);
				worldIn.method_8406(class_2398.field_11240, d0 + d4, d1, d2 + d3, 0.0D, 0.0D, 0.0D);
			}
		}
	}
		
	// BlockMachineBase
	@Override
	public class_2586 method_10123(class_1922 worldIn) {
		return new IronFurnaceBlockEntity();
	}

	@Override
	public IMachineGuiHandler getGui() {
		return EGui.IRON_FURNACE;
	}

	@Override
	public void getDrops(class_2680 state, class_2371<class_1799> drops, class_1937 world, class_2338 pos, int fortune) {
		drops.add(new class_1799(this));
	}
}
