/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2018 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.items.tool;

import reborncore.api.power.EnergyBlockEntity;
import reborncore.common.powerSystem.PowerSystem;
import techreborn.TechReborn;

import java.util.Map.Entry;
import net.minecraft.class_124;
import net.minecraft.class_1269;
import net.minecraft.class_156;
import net.minecraft.class_1792;
import net.minecraft.class_1838;
import net.minecraft.class_2248;
import net.minecraft.class_2378;
import net.minecraft.class_2561;
import net.minecraft.class_2585;
import net.minecraft.class_2586;
import net.minecraft.class_2680;
import net.minecraft.class_2769;

/**
 * Created by Mark on 20/03/2016.
 */
public class ItemDebugTool extends class_1792 {

	public ItemDebugTool() {
		super(new class_1792.class_1793().method_7892(TechReborn.ITEMGROUP));
	}

	@Override
	public class_1269 method_7884(class_1838 context) {
		class_2680 blockState = context.method_8045().method_8320(context.method_8037());
		class_2248 block = blockState.method_11614();
		if (block == null) {
			return class_1269.field_5814;
		}
		sendMessage(context, new class_2585(getRegistryName(block)));
		for (Entry<class_2769<?>, Comparable<?>> entry : blockState.method_11656().entrySet()) {
			sendMessage(context, new class_2585(getPropertyString(entry)));
		}
		class_2586 blockEntity = context.method_8045().method_8321(context.method_8037());
		if (blockEntity != null) {
			sendMessage(context, new class_2585(getBlockEntityType(blockEntity)));
			if (blockEntity instanceof EnergyBlockEntity) {
				sendMessage(context, new class_2585(getRCPower((EnergyBlockEntity) blockEntity)));
			}
		}
		return class_1269.field_5812;
	}

	private void sendMessage(class_1838 context, class_2561 string) {
		if (!context.method_8045().field_9236) {
			context.method_8036().method_9203(string);
		}
	}

	private String getPropertyString(Entry<class_2769<?>, Comparable<?>> entryIn) {
		class_2769<?> iproperty = entryIn.getKey();
		Comparable<?> comparable = entryIn.getValue();
		String s = class_156.method_650(iproperty, comparable);
		if (Boolean.TRUE.equals(comparable)) {
			s = class_124.field_1060 + s;
		} else if (Boolean.FALSE.equals(comparable)) {
			s = class_124.field_1061 + s;
		}

		return iproperty.method_11899() + ": " + s;
	}

	private String getRegistryName(class_2248 block) {
		String s = "" + class_124.field_1060;
		s += "Block Registry Name: ";
		s += class_124.field_1078;
		s += class_2378.field_11146.method_10221(block);

		return s;
	}
	
	private String getBlockEntityType(class_2586 blockEntity) {
		String s = "" + class_124.field_1060;
		s += "Tile Entity: ";
		s += class_124.field_1078;
		s += blockEntity.method_11017().toString();

		return s;
	}
	
	private String getRCPower(EnergyBlockEntity blockEntity) {
		String s = "" + class_124.field_1060;
		s += "Power: ";
		s += class_124.field_1078;
		s += PowerSystem.getLocaliszedPower(blockEntity.getEnergy());
		s += "/";
		s += PowerSystem.getLocaliszedPower(blockEntity.getMaxPower());
		
		return s;
	}
}
